; Echtzeit berechnter Zoom in Mandelbrot / auf P75

code    segment
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin

; ein Tabelleneintrag = 7 * 4 bytes

                ; y = -6 bis 6 / x = -8 bis 4
;pos1    dd      6553 * 256, 4915 * 256, 393216 * 256, 524288 *256
;        dd      262144 * 256, 392124 * 256, 0ffffh*12 * 256
                ; y = -1.5 bis 1.5 / x = -2 bis 1
                ; add_cx=y,  add_dx=x,      sub_cx,      sub_dx,
;pos2    dd      1638 * 256, 1228 * 256, 98304 * 256, 131072 * 256
                ; jmp_v,        leave_cx,       leave_dx
;        dd      262144 * 256, 97212 * 256, 0ffffh*3 * 256

pos1    dw    101, 74, 6042, 7987
        dw    4096, 6042, 11841
pos2    dw    96, 71, 5734, 7578
        dw    4096, 5734, 11366
pos3    dw    90, 67, 5427, 7168
        dw    4096, 5427, 10752
pos4    dw    85, 63, 5120, 6758
        dw    4096, 5120, 10138
pos5    dw    80, 60, 4813, 6349
        dw    4096, 4813, 9601

pos6 dw    75, 55, 4506, 5939
dw    4096, 4506, 8909
pos7 dd    70, 51, 4198, 5530
dd    4096, 4198, 8294
pos8 dd    65, 47, 3891, 5120
dd    4096, 3891, 7680
pos9 dd    60, 43, 3584, 4710
dd    4096, 3584, 7066
pos10 dd    55, 39, 3277, 4301
dd    4096, 3277, 6451
pos11 dd    49, 35, 2970, 3891
dd    4096, 2970, 5837
pos12 dd    44, 32, 2662, 3482
dd    4096, 2662, 5222

quadTab dw      8200    dup (0)
        dw      8200    dup (0)

posCnt  db      0
posNum  db      2

co1     dw      0
co2     dw      0

; Berechnung der Parameter: add_cx|y   = 65535*(|-6|+|6|)/120*256
;                           add_dx|x   = 65535*(|-8|+|4|)/160*256
;                           sub_cx|y   = 65535*(|-6|)*256
;                           sub_dx|x   = 65535*(|-8|)*256
;                           jmp_v      = konst.
;                           leave_cx|y = ((|-6|+|6|)*65535*256) / 2 -1092
;                           leave_dx|x = (|-8|+|4|)*65535*256

createTab       proc
        .286
        mov     ax,cs
        mov     ds,ax
        .386

        mov     ebp,1   ; step-addi von Quadratzahl zu Quadratzahl (2n+1)
        xor     eax,eax ; aktuelle Quadratzahl
        mov     cx,8192

   @lp1:
        add     eax,ebp
        mov     ebx,eax
        shr     ebx,10
        mov     word ptr ds:[bp+quadTab+1],bx
        inc     bp
        inc     bp
        loop    @lp1

        .286
        ret
createTab       endp

loadParam       proc
    .286
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        cld
        mov     di,offset @add_cx+2
        movsb
        inc     si
        mov     di,offset @add_dx+2
        movsb
        inc     si
        mov     di,offset @sub_cx+2
        movsw
        mov     di,offset @sub_dx+2
        movsw
        add     si,2    ; vielleicht brauchen wir den Wert doch mal
        mov     di,offset @cmp_cx+2
        movsw
        mov     di,offset @cmp_dx+2
        movsw

        ret
loadParam       endp

drawFrac        proc
    .286
        mov     ax,0a000h
        mov     es,ax

        ; ----> Variablen/Code mit Startwerten besetzen
        mov     co1,12720
        mov     co2,51120
    .386
        xor     cx,cx           ; y - Zhler (imag)

    yloop:                      ; Schritteweitekonstante an 26bit und Gre angepat
        @add_cx:                ; y - Schrittweite -> Transformation
        add     cx,0ffh         ; y-Schrittweite = 3*16b / 180 = 20b->3145728/180
        xor     dx,dx           ; x - Zhler (real)

        add     co1,159         ; bildschirmzhler oben
        sub     co2,481         ;  - " - unten

    xloop:                      ; siehe oben
        @add_dx:                ; x - Schrittweite -> Transformation
        add     dx,0ffh

        inc     co1             ; bildschirmzhler oben und unten
        inc     co2

      ; ----> rek-tiefe berechnen
        ; eax wird reell-Teil und ebx imag.-teil / esi ist Puffer
        ; x' = x2 - y2 + a    /    y' = 2xy + b

        push    cx
        push    dx

@sub_cx:
        sub     cx,0ffffh       ; wird gepatcht
@sub_dx:
        sub     dx,0ffffh       ; -  "  -

        xor     ax,ax           ; immer mit 0 anfangen
        xor     bx,bx
        xor     bp,bp

    iloop:
        push    ax
        push    bx

          push    dx

            push    bp

            mov     bp,ax
            cmp     bp,32768    ;vorzeichen killen
            jb      @getch1
            xor     bp,0ffffh
         @getch1:
            shl     bp,1
            mov     ax,word ptr ds:[bp+quadTab]

            xchg    ax,bx

            mov     bp,ax
            cmp     bp,32768    ;vorzeichen killen
            jb      @getch2
            xor     bp,0ffffh
         @getch2:
            shl     bp,1
            mov     ax,word ptr ds:[bp+quadTab]

            pop     bp

          pop     dx

        mov     di,ax
        add     di,bx
 @jmp_v:
        cmp     di,4096       ; >4 dann weg
        ja      @fin
        inc bp                  ; Farbe incr.

        sub     bx,ax           ; x2-y2 (eax und ebx getauscht)
        add     bx,dx           ; + a
        mov     di,bx           ; Puffer fr x'

        pop     bx
        pop     ax

        push    dx

        imul    bx
        shrd    ax,dx,10
        shl     ax,1            ; Ergebnis noch mal 2 nehmen! ( -> y'=x*y*2 )

        add     ax,cx           ; y' fertig machen
        pop     dx

        mov     bx,di
        xchg    ax,bx

        cmp     bp,64           ; hier Tsch (iterationstiefe)
        jb      iloop

        xor     bp,bp
        jmp     @fin3

       @fin:
        pop     bx
        pop     ax

       @fin3:
        pop     dx
        pop     cx

      ; Pixel setzen
        mov     ax,bp                   ; Farbe in ah speichern

        mov     di,co1
        mov     byte ptr es:[di],al     ; Farbe in al / zwei Zhler fr
        mov     di,co2
        mov     byte ptr es:[di],al     ; oben und unten

      ; ----> xloop-cmp
 @cmp_dx:
        cmp     dx,0ffffh
        jb      xloop

      ; ----> yloop-cmp
 @cmp_cx:
        cmp     cx,0ffffh
        jb      yloop

        ret
drawFrac        endp

  begin:
        mov     ax,0013h
        int     10h
        push    cs
        pop     ds
        cld

        call    createTab

        mov     si,offset pos1
        call    loadParam
        call    drawFrac
jmp done
        mov     si,offset pos2
        call    loadParam
        call    drawFrac

        mov     si,offset pos3
        call    loadParam
        call    drawFrac

        mov     si,offset pos4
        call    loadParam
        call    drawFrac

        mov     si,offset pos5
        call    loadParam
        call    drawFrac

        mov     si,offset pos6
        call    loadParam
        call    drawFrac

        mov     si,offset pos7
        call    loadParam
        call    drawFrac

        mov     si,offset pos8
        call    loadParam
        call    drawFrac

        mov     si,offset pos9
        call    loadParam
        call    drawFrac

        mov     si,offset pos10
        call    loadParam
        call    drawFrac

        mov     si,offset pos11
        call    loadParam
        call    drawFrac

        mov     si,offset pos12
        call    loadParam
        call    drawFrac
jmp done
  done:
        mov     ax,0
        int     16h
        mov     ax,0003h
        int     10h
        mov     ah,4ch
        int     21h

code    ends
        end     entry

