; Echtzeit berechnter Zoom in Mandelbrot / auf P75

code    segment
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin

; ein Tabelleneintrag = 7 * 4 bytes

                ; y = -6 bis 6 / x = -8 bis 4
;pos1    dd      6553 * 256, 4915 * 256, 393216 * 256, 524288 *256
;        dd      262144 * 256, 392124 * 256, 0ffffh*12 * 256
                ; y = -1.5 bis 1.5 / x = -2 bis 1
                ; add_cx=y,  add_dx=x,      sub_cx,      sub_dx,
;pos2    dd      1638 * 256, 1228 * 256, 98304 * 256, 131072 * 256
                ; jmp_v,        leave_cx,       leave_dx
;        dd      262144 * 256, 97212 * 256, 0ffffh*3 * 256

pos1    dw    101, 74, 6042, 7987
        dw    4096, 6042, 11841
pos2    dw    96, 71, 5734, 7578
        dw    4096, 5734, 11366
pos3    dw    90, 67, 5427, 7168
        dw    4096, 5427, 10752
pos4    dw    85, 63, 5120, 6758
        dw    4096, 5120, 10138
pos5    dw    80, 60, 4813, 6349
        dw    4096, 4813, 9601
pos6    dw    75, 55, 4506, 5939
dw    4096, 4506, 8801
pos7    dw    70, 51, 4198, 5530
dw    4096, 4198, 8161
pos8    dw    65, 48, 3891, 5120
dw    4096, 3891, 7681
pos9    dw    60, 44, 3584, 4710
dw    4096, 3584, 7041
pos10    dw    55, 40, 3277, 4301
dw    4096, 3277, 6401
pos11    dw    49, 36, 2970, 3891
dw    4096, 2970, 5761
pos12    dw    44, 32, 2662, 3482
dw    4096, 2662, 5121
pos13    dw    39, 28, 2355, 3072
dw    4096, 2355, 4481
pos14    dw    34, 24, 2048, 2662
dw    4096, 2048, 3841
pos15    dw    29, 21, 1741, 2253
dw    4096, 1741, 3361
pos16    dw    24, 17, 1434, 1843
dw    4096, 1434, 2721
pos17    dw    19, 13, 1126, 1434
dw    4096, 1126, 2081
pos18    dw    14, 9, 819, 1024
dw    4096, 819, 1441
pos19    dw    9, 5, 512, 614
dw    4096, 512, 801
pos20    dw    3, 1, 205, 205
dw    4096, 205, 161

quadTab dw      8200    dup (0)

posCnt  db      0
posNum  db      2

co1     dw      0
co2     dw      0
xb      dw      0
yb      dw      0


; Berechnung der Parameter: add_cx|y   = 65535*(|-6|+|6|)/120*256
;                           add_dx|x   = 65535*(|-8|+|4|)/160*256
;                           sub_cx|y   = 65535*(|-6|)*256
;                           sub_dx|x   = 65535*(|-8|)*256
;                           jmp_v      = konst.
;                           leave_cx|y = ((|-6|+|6|)*65535*256) / 2 -1092
;                           leave_dx|x = (|-8|+|4|)*65535*256

createTab       proc
        .286
        mov     ax,cs
        mov     ds,ax
        .386

        mov     ebp,1   ; step-addi von Quadratzahl zu Quadratzahl (2n+1)
        xor     eax,eax ; aktuelle Quadratzahl
        mov     cx,8192

   @lp1:
        add     eax,ebp
        mov     ebx,eax
        shr     ebx,10
        mov     word ptr ds:[bp+quadTab+1],bx
        inc     bp
        inc     bp
        loop    @lp1

        .286
        ret
createTab       endp

loadParam       proc
    .286
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
        cld
        mov     di,offset @add_cx+2
        movsb
        inc     si
        mov     di,offset @add_dx+2
        movsb
        inc     si
        mov     di,offset @sub_cx+2
        movsw
        mov     di,offset @sub_dx+2
        movsw
        add     si,2    ; vielleicht brauchen wir den Wert doch mal
        mov     di,offset @cmp_cx+2
        movsw
        mov     di,offset @cmp_dx+2
        movsw

        ret
loadParam       endp

drawFrac        proc
    .286
        mov     ax,0a000h
        mov     es,ax

        ; ----> Variablen/Code mit Startwerten besetzen
        mov     co1,12720
        mov     co2,51120
    .386
        xor     cx,cx           ; y - Zhler (imag)

    yloop:                      ; Schritteweitekonstante an 26bit und Gre angepat
        @add_cx:                ; y - Schrittweite -> Transformation
        add     cx,0ffh         ; y-Schrittweite = 3*16b / 180 = 20b->3145728/180
        xor     dx,dx           ; x - Zhler (real)

        add     co1,159         ; bildschirmzhler oben
        sub     co2,481         ;  - " - unten

    xloop:                      ; siehe oben
        @add_dx:                ; x - Schrittweite -> Transformation
        add     dx,0ffh

        inc     co1             ; bildschirmzhler oben und unten
        inc     co2

      ; ----> rek-tiefe berechnen
        ; eax wird reell-Teil und ebx imag.-teil / esi ist Puffer
        ; x' = x2 - y2 + a    /    y' = 2xy + b

        push    cx
        push    dx

@sub_cx:
        sub     cx,0ffffh       ; wird gepatcht
@sub_dx:
        sub     dx,0ffffh       ; -  "  -

        mov     xb,0            ; 1
        mov     yb,0

        xor     ax,ax           ; immer mit 0 anfangen
        xor     bx,bx           ; alle 1 - genauso schnell wie mov!
        xor     si,si

    iloop:
        push    ax              ; 1
        push    bx              ; 1

            mov     bp,ax       ; 1 cyc - all for 486 / not avaible for pentium
            xchg    ax,bx       ; 3 cyc
            cmp     bp,32768    ; 1 cyc
            jb      @getch1     ; jmp=3 / nojmp=1
            xor     bp,0ffffh   ; 1 cyc
         @getch1:
            shl     bp,1
            mov     bx,word ptr ds:[quadTab+bp]; 1

            ; bx = x^2

            mov     bp,ax
            cmp     bp,32768    ;vorzeichen killen
            jb      @getch2
            xor     bp,0ffffh
         @getch2:
           shl     bp,1
            mov     ax,word ptr ds:[quadTab+bp]

            ; ax = y^2

        mov     di,ax           ; di = x^2+y^2
        add     di,bx
 @jmp_v:
        cmp     di,4096         ; >4 dann weg
        ja      @fin
        inc     si              ; Farbe incr.

        sub     bx,ax           ; x2-y2 (eax und ebx getauscht)
        add     bx,dx           ; + a
        mov     di,bx           ; Puffer fr x'

        pop     bx              ; 4
        pop     ax              ; 4
                                ; i = sqrt (-1) / i^2 = -1
                                ; trick: (x+yi)^2=x^2+2xyi-y^2
        push    dx

        imul    bx
        shrd    ax,dx,10
        shl     ax,1            ; Ergebnis noch mal 2 nehmen! ( -> y'=x*y*2 )

        add     ax,cx           ; y' fertig machen / param-cx addieren
        pop     dx

        mov     bx,di           ; x' zwischengespeichert
        xchg    ax,bx

        cmp     si,16           ; hier Tsch (iterationstiefe)
        jb      iloop

        xor     si,si
        jmp     @fin3

       @fin:
        pop     bx
        pop     ax

       @fin3:
        pop     dx
        pop     cx

      ; Pixel setzen
        mov     ax,si                   ; Farbe in ah speichern

        mov     di,co1
        mov     byte ptr es:[di],al     ; Farbe in al / zwei Zhler fr
        mov     di,co2
        mov     byte ptr es:[di],al     ; oben und unten

      ; ----> xloop-cmp
 @cmp_dx:
        cmp     dx,0ffffh
        jb      xloop

      ; ----> yloop-cmp
 @cmp_cx:
        cmp     cx,0ffffh
        jb      yloop

        ret
drawFrac        endp

  begin:
        mov     ax,0013h
        int     10h
        push    cs
        pop     ds
        cld

        call    createTab

        mov     si,offset pos1
        call    loadParam
        call    drawFrac

        mov     si,offset pos2
        call    loadParam
        call    drawFrac

        mov     si,offset pos3
        call    loadParam
        call    drawFrac

        mov     si,offset pos4
        call    loadParam
        call    drawFrac

        mov     si,offset pos5
        call    loadParam
        call    drawFrac

        mov     si,offset pos6
        call    loadParam
        call    drawFrac

        mov     si,offset pos7
        call    loadParam
        call    drawFrac

        mov     si,offset pos8
        call    loadParam
        call    drawFrac

        mov     si,offset pos9
        call    loadParam
        call    drawFrac

        mov     si,offset pos10
        call    loadParam
        call    drawFrac

        mov     si,offset pos11
        call    loadParam
        call    drawFrac

        mov     si,offset pos12
        call    loadParam
        call    drawFrac

        mov     si,offset pos13
        call    loadParam
        call    drawFrac

        mov     si,offset pos14
        call    loadParam
        call    drawFrac

        mov     si,offset pos15
        call    loadParam
        call    drawFrac

        mov     si,offset pos16
        call    loadParam
        call    drawFrac

        mov     si,offset pos17
        call    loadParam
        call    drawFrac

        mov     si,offset pos18
        call    loadParam
        call    drawFrac

        mov     si,offset pos19
        call    loadParam
        call    drawFrac

        mov     si,offset pos20
        call    loadParam
        call    drawFrac

  done:
        mov     ax,0
        int     16h
        mov     ax,0003h
        int     10h
        mov     ah,4ch
        int     21h

code    ends
        end     entry

