; Echtzeit berechnter Zoom in Mandelbrot / auf P75

code    segment
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin

; Wertetabelle fr Kamerafahrt

posCnt  db      0
posNum  db      2

co1     dw      0
co2     dw      0

; Berechnung der Parameter: add_cx|y   = 65535*(|-6|+|6|)/120*256
;                           add_dx|x   = 65535*(|-8|+|4|)/160*256
;                           sub_cx|y   = 65535*(|-6|)*256
;                           sub_dx|x   = 65535*(|-8|)*256
;                           jmp_v      = konst.
;                           leave_cx|y = ((|-6|+|6|)*65535*256) / 2 -1092
;                           leave_dx|x = (|-8|+|4|)*65535*256

; ein Tabelleneintrag = 7 * 4 bytes

                ; y = -6 bis 6 / x = -8 bis 4
;pos1    dd      6553 * 256, 4915 * 256, 393216 * 256, 524288 *256
;        dd      262144 * 256, 392124 * 256, 0ffffh*12 * 256
                ; y = -1.5 bis 1.5 / x = -2 bis 1
                ; add_cx=y,  add_dx=x,      sub_cx,      sub_dx,
;pos2    dd      1638 * 256, 1228 * 256, 98304 * 256, 131072 * 256
                ; jmp_v,        leave_cx,       leave_dx
;        dd      262144 * 256, 97212 * 256, 0ffffh*3 * 256

pos1    dd  6444, 4792, 386657, 511173
        dd  262144 * 1, 385565, 766760
pos2    dd  6117, 4546, 366996, 484959
        dd  262144 * 1, 365904, 727439
pos3    dd  5789, 4300, 347336, 458745
        dd  262144 * 1, 346244, 688118
pos4    dd  5461, 4054, 327675, 432531
        dd  262144 * 1, 326583, 648796
pos5    dd  5134, 3808, 308014, 406317
        dd  262144 * 1, 306922, 609475
pos6    dd  4806, 3562, 288354, 380103
        dd  262144 * 1, 287262, 570155
pos7    dd  4478, 3317, 268693, 353889
        dd  262144 * 1, 267601, 530834
pos8    dd  4151, 3071, 249033, 327675
        dd  262144 * 1, 247941, 491512
pos9    dd  3823, 2825, 229372, 301461
        dd  262144 * 1, 228280, 452191
pos10   dd  3495, 2579, 209712, 275247
        dd  262144 * 1, 208620, 412870
pos11   dd  3168, 2334, 190052, 249033
        dd  262144 * 1, 188960, 373549
pos12   dd  2840, 2088, 170391, 222819
        dd  262144 * 1, 169299, 334229

loadParam       proc
    .286
        mov     ax,cs
        mov     ds,ax
        mov     es,ax
    .386
        ;mov     si,offset pos1
        mov     di,offset @add_cx+3
        movsd
        mov     di,offset @add_dx+3
        movsd
        mov     di,offset @sub_cx+3
        movsd
        mov     di,offset @sub_dx+3
        movsd
        add     si,4    ;
        mov     di,offset @cmp_cx+3
        movsd
        mov     di,offset @cmp_dx+3
        movsd
    .286

        ret
loadParam       endp

drawFrac        proc
    .286
        mov     ax,0a000h
        mov     es,ax

        ; ----> Variablen/Code mit Startwerten besetzen
        mov     co1,12720
        mov     co2,51120

    .386
        xor     ecx,ecx         ; y - Zhler

    yloop:                      ; Schritteweitekonstante an 26bit und Gre angepat
        @add_cx:                ; y - Schrittweite -> Transformation
        add     ecx,6553        ; y-Schrittweite = 3*16b / 180 = 20b->3145728/180
        xor     edx,edx         ; x - Zhler

        ;mov     si,80
        ;add     di,320

        add     co1,159         ; bildschirmzhler oben
        sub     co2,481

    xloop:                      ; siehe oben
        @add_dx:                ; x - Schrittweite -> Transformation
        add     edx,4915

        inc     co1             ; bildschirmzhler oben
        inc     co2

      ; ----> rek-tiefe berechnen
        ; eax wird reell-Teil und ebx imag.-teil / esi ist Puffer
        ; x' = x2 - y2 + a    /    y' = 2xy + b

        push    ecx
        push    edx

 @sub_cx:
        sub     ecx,393216
 @sub_dx:
        sub     edx,524288

        xor     eax,eax         ; immer mit 0 anfangen
        xor     ebx,ebx
        xor     bp,bp

    iloop:
        push    eax
        push    ebx

          push    edx

            mov     esi,eax             ; zeiiiiiiiiiiiiiittttttttttt!!!
            imul    esi                 ; 12-42cycles!!!!!!!!!!!!!!!!!!!
            shrd    eax,edx,16          ; viel zu langsam!!!!!!!!!!!!!!!

            xchg    eax,ebx

            mov     esi,eax
            imul    esi
            shrd    eax,edx,16

          pop     edx

        mov     edi,eax
        add     edi,ebx
 @jmp_v:
        cmp     edi,262144    ; >4 dann weg
        ja      @fin
        inc bp                ; Farbe incr.

        sub     ebx,eax       ; x2-y2 (eax und ebx getauscht)
        add     ebx,edx       ; + a
        mov     edi,ebx       ; Puffer fr x'

        pop     ebx
        pop     eax

        push    edx

        imul    ebx
        shrd    eax,edx,16
        shl     eax,1         ; Ergebnis noch mal 2 nehmen! ( -> y'=x*y*2 )

        add     eax,ecx       ; y' fertig machen
        pop     edx

        mov     ebx,edi
        xchg    eax,ebx

        cmp     bp,16         ; hier Tsch (iterationstiefe)
        jb      iloop

        xor     bp,bp
        jmp     @fin3

       @fin:
        pop     ebx
        pop     eax

       @fin3:
        pop     edx
        pop     ecx

      ; Pixel setzen
        mov     ax,bp                   ; Farbe in ah speichern

        mov     di,co1
        mov     byte ptr es:[di],al     ; Farbe in al / zwei Zhler fr
        mov     di,co2
        mov     byte ptr es:[di],al     ; oben und unten

      ; ----> xloop-cmp
 @cmp_dx:
        cmp     edx,0ffffh*12
        jb      xloop

      ; ----> yloop-cmp
 @cmp_cx:
        cmp     ecx,392124
        jb      yloop

        ret
drawFrac        endp

  begin:
        mov     ax,0013h
        int     10h
        push    cs
        pop     ds
        cld

        mov     si,offset pos1
        call    loadParam
        call    drawFrac

        mov     si,offset pos2
        call    loadParam
        call    drawFrac

        mov     si,offset pos3
        call    loadParam
        call    drawFrac

        mov     si,offset pos4
        call    loadParam
        call    drawFrac

        mov     si,offset pos5
        call    loadParam
        call    drawFrac

        mov     si,offset pos6
        call    loadParam
        call    drawFrac

        mov     si,offset pos7
        call    loadParam
        call    drawFrac

        mov     si,offset pos8
        call    loadParam
        call    drawFrac

        mov     si,offset pos9
        call    loadParam
        call    drawFrac

        mov     si,offset pos10
        call    loadParam
        call    drawFrac

        mov     si,offset pos11
        call    loadParam
        call    drawFrac

        mov     si,offset pos12
        call    loadParam
        call    drawFrac

  done:
        mov     ax,0
        int     16h
        mov     ax,0003h
        int     10h
        mov     ah,4ch
        int     21h

code    ends
        end     entry

